/**
 * Semi-automatically generated files used to measure predicate coverage.
 * Details can be found at http://mir.cs.illinois.edu/coverage
 */
package predicate.heaparray;

public class HeapArray_pred {

    private int EMPTY_VALUE = -1;

    public int size;
    public int array[];
    public int arraylength;

    public HeapArray_pred() {
        array = new int[0];
    }

    public int getSize() {
        return size;
    }

    private void resize(int newsize, boolean isInsert) {
        int[] newArray = new int[newsize];
        if (array != null && newArray != null) {
            executedPredicate(0, 0);
            for (int i = 0; i < (isInsert ? size : newsize); i++) {
                executedPredicate(2, i);
                newArray[i] = array[i];
            }
            executedPredicate(3, 0);
        } else {
            executedPredicate(1, 0);
        }

        array = newArray;
        arraylength = newsize;
    }

    public void insert(int value) {
        if (size == arraylength) {
            executedPredicate(4, 0);
            resize(size + 1, true);
        } else {
            executedPredicate(5, 0);
        }

        array[size] = value;
        int i = size;
        while (true) {
            executedPredicate(6, 0);
            int parent = (i - 1) / 2;
            if (parent < 0) {
                executedPredicate(8, 0);
                break;
            } else {
                executedPredicate(9, parent);
            }

            if (array[i] > array[parent]) {
                executedPredicate(10, i);
                {
                    int temp = array[i];
                    array[i] = array[parent];
                    array[parent] = temp;
                    i = parent;
                }
            } else {
                executedPredicate(11, parent);
                break;
            }
        }
        executedPredicate(7, 0);
        size++;
    }

    public int remove() {
        if (size == 0) {
            executedPredicate(12, 0);
            return EMPTY_VALUE;
        } else {
            executedPredicate(13, 0);
        }

        int ret = array[0];
        array[0] = array[size - 1];
        if (size == arraylength) {
            executedPredicate(14, 0);
            resize(size - 1, false);
        } else {
            executedPredicate(15, 0);
        }

        size--;
        int i = 0;
        while (size != 0) {
            executedPredicate(16, i);
            int left = 2 * i + 1;
            int right = 2 * i + 2;
            if (left >= size) {
                executedPredicate(18, i);
                break;
            } else {
                executedPredicate(19, i);
            }

            if (array[i] < array[left]) {
                executedPredicate(20, i);
                int temp = array[i];
                array[i] = array[left];
                array[left] = temp;
                i = left;
                continue;
            } else {
                executedPredicate(21, i);
            }

            if (right >= size) {
                executedPredicate(22, i);
                break;
            } else {
                executedPredicate(23, i);
            }

            if (array[i] < array[right]) {
                executedPredicate(24, i);
                int temp = array[i];
                array[i] = array[right];
                array[right] = temp;
                i = right;
            } else {
                executedPredicate(25, i);
            }
            size--;
        }
        executedPredicate(17, 0);
        return ret;
    }

    @Override
    public String toString() {
        String s = "[ size = " + size + " ][ length = " + array.length
                + " ] { ";
        for (int i = 0; i < array.length; i++) {
            executedPredicate(26, 0);
            if (i == 0) {
                executedPredicate(28, i);
                s += "[ROOT]";
            } else {
                executedPredicate(29, i);
                if (i % 2 == 1 && i + 1 < array.length) {
                    executedPredicate(30, i);
                    s += array[i] <= array[i + 1] ? "[L, G] " : "[G, L]";
                    i++;
                } else {
                    executedPredicate(31, i);
                    s += "[L]";
                }
            }
        }
        executedPredicate(27, 0);

        return s += "}";
    }

    private static int NUM_OF_PREDICATES = 3;

    public static int numOfPredicates() {
        return NUM_OF_PREDICATES;
    }

    public void executedPredicate(int branch_id, int i) {
        int res = 0;
        if (i == 0)
            res |= 1 << 0;
        else if (i % 2 == 1 && i + 1 < array.length)
            res |= array[i] <= array[i + 1] ? 0 : 1 << 1;
        else
            res |= 1 << 2;
        System.out.println("branchId=" + branch_id + "; covered predicate combination=" + res);
    }

}
