/**
 * Semi-automatically generated files used to measure predicate coverage.
 * Details can be found at http://mir.cs.illinois.edu/coverage
 */
package predicate.intredblacktree;

public class IntRedBlackTree_pred {

    protected final static boolean RED = false;
    protected final static boolean BLACK = true;

    protected Node root;
    protected int size;

    public static class Node {
        int key;
        Object value;
        Node parent;
        Node left, right;
        boolean color;

        @Override
        public String toString() {
            String s = "{c:" + color + ";v" + value + "["
                    + (left != null ? left.toString() : null) + "]["
                    + (right != null ? right.toString() : null) + "]}";
            return s;
        }

    }

    protected Node parent(Node n) {
        return n == null ? null : n.parent;
    }

    protected Node left(Node n) {
        return n == null ? null : n.left;
    }

    protected Node right(Node n) {
        return n == null ? null : n.right;
    }

    public boolean containsKey(Integer key) {
        return findNode(key) != null;
    }

    public Object get(Integer key) {
        Node x = findNode(key);
        return x == null ? null : x.value;
    }

    public void put(Integer key, Object value) {
        Node x = new Node();
        x.key = key;
        x.value = value;
        treeInsert(x);
        size++;
    }

    public Object remove(Integer key) {
        Node ret = treeDelete(findNode(key));
        if (ret == null) {
            executedPredicate(0, null);
            return null;
        } else {
            executedPredicate(1, ret);
        }

        size--;
        return ret.value;
    }

    protected boolean getColor(Node x) {
        return x == null ? BLACK : x.color;
    }

    protected void setColor(Node x, boolean color) {
        if (x != null) {
            executedPredicate(2, x);
            x.color = color;
        } else {
            executedPredicate(3, null);
        }
    }

    protected Node findNode(Integer key) {
        Node cur = root;
        while (cur != null && key.compareTo(cur.key) != 0) {
            executedPredicate(4, cur);
            if (key.compareTo(cur.key) < 0) {
                executedPredicate(6, cur);
                cur = cur.left;
            } else {
                executedPredicate(7, cur);
                cur = cur.right;
            }
        }
        executedPredicate(5, cur);
        return cur;
    }

    protected void leftRotate(Node x) {
        Node y = x.right;
        x.right = y.left;
        if (y.left != null) {
            executedPredicate(8, y);
            y.left.parent = x;
        } else {
            executedPredicate(9, y);
        }

        y.parent = x.parent;
        if (x.parent == null) {
            executedPredicate(10, y);
            root = y;
        } else {
            executedPredicate(11, x);
            if (x == x.parent.left) {
                executedPredicate(12, y);
                x.parent.left = y;
            } else {
                executedPredicate(13, y);
                x.parent.right = y;
            }
        }

        y.left = x;
        x.parent = y;
    }

    protected void rightRotate(Node x) {
        Node y = x.left;
        x.left = y.right;
        if (y.right != null) {
            executedPredicate(14, y);
            y.right.parent = x;
        } else {
            executedPredicate(15, y);
        }

        y.parent = x.parent;
        if (x.parent == null) {
            executedPredicate(16, y);
            root = y;
        } else {
            executedPredicate(17, y);
            if (x == x.parent.right) {
                executedPredicate(18, y);
                x.parent.right = y;
            } else {
                executedPredicate(19, y);
                x.parent.left = y;
            }
        }

        y.right = x;
        x.parent = y;
    }

    protected void treeInsert(Node z) {
        Node y = null;
        Node x = root;
        while (x != null) {
            executedPredicate(20, x);
            y = x;
            if (((Integer) z.key).compareTo(x.key) < 0) {
                executedPredicate(22, y);
                x = x.left;
            } else {
                executedPredicate(23, y);
                if (((Integer) z.key).compareTo(x.key) == 0) {
                    executedPredicate(24, y);
                    {
                        x.value = z.value;
                        size--;
                        return;
                    }
                } else {
                    executedPredicate(25, y);
                    x = x.right;
                }
            }
        }
        executedPredicate(21, y);
        z.parent = y;
        if (y == null) {
            executedPredicate(26, y);
            root = z;
        } else {
            executedPredicate(27, y);
            if (((Integer) z.key).compareTo(y.key) < 0) {
                executedPredicate(28, y);
                y.left = z;
            } else {
                executedPredicate(29, y);
                y.right = z;
            }
        }

        z.left = null;
        z.right = null;
        z.color = RED;
        treeInsertFix(z);
    }

    protected void treeInsertFix(Node z) {
        while (getColor(z.parent) == RED) {
            executedPredicate(30, z);
            if (parent(z) == left(parent(parent(z)))) {
                executedPredicate(32, z);
                Node y = right(parent(parent(z)));
                if (getColor(y) == RED) {
                    executedPredicate(34, y);
                    setColor(parent(z), BLACK);
                    setColor(y, BLACK);
                    setColor(parent(parent(z)), RED);
                    z = parent(parent(z));
                } else {
                    executedPredicate(35, y);
                    if (z == right(parent(z))) {
                        executedPredicate(36, y);
                        z = parent(z);
                        leftRotate(z);
                    } else {
                        executedPredicate(37, y);
                    }

                    setColor(parent(z), BLACK);
                    setColor(parent(parent(z)), RED);
                    if (parent(parent(z)) != null) {
                        executedPredicate(38, y);
                        rightRotate(parent(parent(z)));
                    } else {
                        executedPredicate(39, y);
                    }
                }
            } else {
                executedPredicate(33, z);
                {
                    Node y = left(parent(parent(z)));
                    if (getColor(y) == RED) {
                        executedPredicate(40, y);
                        {
                            setColor(parent(z), BLACK);
                            setColor(y, BLACK);
                            setColor(parent(parent(z)), RED);
                            z = parent(parent(z));
                        }
                    } else {
                        executedPredicate(41, y);
                        {
                            if (z == left(parent(z))) {
                                executedPredicate(42, y);
                                {
                                    z = parent(z);
                                    rightRotate(z);
                                }
                            } else {
                                executedPredicate(43, y);
                            }

                            setColor(parent(z), BLACK);
                            setColor(parent(parent(z)), RED);
                            if (parent(parent(z)) != null) {
                                executedPredicate(44, y);
                                leftRotate(parent(parent(z)));
                            } else {
                                executedPredicate(45, y);
                            }

                        }
                    }

                }
            }
        }
        executedPredicate(31, z);
        root.color = BLACK;
    }

    protected Node treeDelete(Node z) {
        if (z == null) {
            executedPredicate(46, null);
            return null;
        } else {
            executedPredicate(47, z);
        }

        Node x, y;
        if (z.left == null || z.right == null) {
            executedPredicate(48, z);
            y = z;
        } else {
            executedPredicate(49, z);
            y = getIOS(z);
        }

        if (y.left != null) {
            executedPredicate(50, y);
            x = y.left;
        } else {
            executedPredicate(51, y);
            x = y.right;
        }

        if (x != null) {
            executedPredicate(52, x);
            x.parent = y.parent;
        } else {
            executedPredicate(53, null);
        }

        if (y.parent == null) {
            executedPredicate(54, y);
            root = x;
        } else {
            executedPredicate(55, y);
            if (y == y.parent.left) {
                executedPredicate(56, y);
                y.parent.left = x;
            } else {
                executedPredicate(57, y);
                y.parent.right = x;
            }
        }

        if (y != z) {
            executedPredicate(58, z);
            z.key = y.key;
            z.value = y.value;
        } else {
            executedPredicate(59, z);
        }

        if (getColor(y) == BLACK) {
            executedPredicate(60, y);
            if (x == null) {
                executedPredicate(62, y);
                treeDeleteFix(y);
            } else {
                executedPredicate(63, x);
                treeDeleteFix(x);
            }
        } else {
            executedPredicate(61, x);
        }

        return y;
    }

    protected void treeDeleteFix(Node x) {
        while (x.parent != null && getColor(x) == BLACK) {
            executedPredicate(64, x);
            if (x == x.parent.left || x.parent.left == null) {
                executedPredicate(66, x);
                Node w = x.parent.right;
                if (w == null) {
                    executedPredicate(68, null);
                    return;
                } else {
                    executedPredicate(69, w);
                }

                if (getColor(w) == RED) {
                    executedPredicate(70, w);
                    w.color = BLACK;
                    x.parent.color = RED;
                    leftRotate(x.parent);
                    w = x.parent.right;
                } else {
                    executedPredicate(71, w);
                }

                if (getColor(w.left) == BLACK && getColor(w.right) == BLACK) {
                    executedPredicate(72, w);
                    w.color = RED;
                    x = x.parent;
                } else {
                    executedPredicate(73, w);
                    if (getColor(w.right) == BLACK) {
                        executedPredicate(74, w);
                        w.left.color = BLACK;
                        rightRotate(w);
                        w = x.parent.right;
                    } else {
                        executedPredicate(75, w);
                    }

                    w.color = x.parent.color;
                    x.parent.color = BLACK;
                    if (w.right != null) {
                        executedPredicate(76, w);
                        w.right.color = BLACK;
                    } else {
                        executedPredicate(77, w);
                    }

                    leftRotate(x.parent);
                    x = root;
                }
            } else {
                executedPredicate(67, x);
                Node w = x.parent.left;
                if (w == null) {
                    executedPredicate(78, null);
                    return;
                } else {
                    executedPredicate(79, w);
                }

                if (getColor(w) == RED) {
                    executedPredicate(80, w);
                    w.color = BLACK;
                    x.parent.color = RED;
                    rightRotate(x.parent);
                    w = x.parent.left;
                } else {
                    executedPredicate(81, w);
                }

                if (getColor(w.right) == BLACK && getColor(w.left) == BLACK) {
                    executedPredicate(82, w);
                    w.color = RED;
                    x = x.parent;
                } else {
                    executedPredicate(83, w);
                    if (getColor(w.left) == BLACK) {
                        executedPredicate(84, w);
                        w.right.color = BLACK;
                        leftRotate(w);
                        w = x.parent.left;
                    } else {
                        executedPredicate(85, w);
                    }

                    w.color = x.parent.color;
                    x.parent.color = BLACK;
                    if (w.left != null) {
                        executedPredicate(86, w);
                        w.left.color = BLACK;
                    } else {
                        executedPredicate(87, w);
                    }

                    rightRotate(x.parent);
                    x = root;
                }
            }
        }
        executedPredicate(65, x);
        x.color = BLACK;
    }

    protected Node getIOS(Node z) {
        Node x, y = null;
        x = z.right;
        while (x != null) {
            executedPredicate(88, x);
            y = x;
            x = x.left;
        }
        executedPredicate(89, z);
        return y;
    }

    @Override
    public String toString() {
        return root == null ? "null" : root.toString();
    }

    private static int NUM_OF_PREDICATES = 6;

    public static int numOfPredicates() {
        return NUM_OF_PREDICATES;
    }

    public void executedPredicate(int branch_id, Node n) {
        int res = 0;
        if (n != null) {
            res |= 1 << 0;
            res |= (n.left == null) ? 0 : 1 << 1;
            res |= (n.right == null) ? 0 : 1 << 2;
            res |= (n.parent == null) ? 0 : 1 << 3;
            res |= (n.color == RED) ? 0 : 1 << 4;
            res |= (n == root) ? 0 : 1 << 5;
        }
        System.out.println("branchId=" + branch_id + "; covered predicate combination=" + res);
    }

}
