/**
 * Semi-automatically generated files used to measure predicate coverage.
 * Details can be found at http://mir.cs.illinois.edu/coverage
 */
package predicate.issta2006.binomialheap;

public class BinomialHeap_pred {

    public static class BinomialHeapNode {
        private int key;

        private int degree;

        private BinomialHeapNode parent;
        private BinomialHeapNode sibling;
        private BinomialHeapNode child;

        public BinomialHeapNode(int k) {
            key = k;
            degree = 0;
            parent = null;
            sibling = null;
            child = null;
        }

        @Override
        public String toString() {
            String res = "{" + "[" + key + "]" + "[" + degree + "]" + "{"
                    + (sibling != null ? sibling.toString() : null) + "}" + "("
                    + (child != null ? child.toString() : null) + ")}";
            return res;
        }

        public int getKey() {
            return key;
        }

        private void setKey(int value) {
            key = value;
        }

        public int getDegree() {
            return degree;
        }

        private void setDegree(int deg) {
            degree = deg;
        }

        public BinomialHeapNode getParent() {
            return parent;
        }

        private void setParent(BinomialHeapNode par) {
            parent = par;
        }

        public BinomialHeapNode getSibling() {
            return sibling;
        }

        private void setSibling(BinomialHeapNode nextBr) {
            sibling = nextBr;
        }

        public BinomialHeapNode getChild() {
            return child;
        }

        private void setChild(BinomialHeapNode firstCh) {
            child = firstCh;
        }

        public int getSize() {
            return (1 + ((child == null) ? 0 : child.getSize()) + ((sibling == null) ? 0
                    : sibling.getSize()));
        }

        private BinomialHeapNode reverse(BinomialHeapNode sibl) {
            BinomialHeapNode ret;
            if (sibling != null) {
                executedPredicate(0, sibl, null);
                ret = sibling.reverse(this);
            } else {
                executedPredicate(1, null, null);
                ret = this;
            }

            sibling = sibl;
            return ret;
        }

        private BinomialHeapNode findMinNode() {
            BinomialHeapNode x = this, y = this;
            int min = x.key;
            while (x != null) {
                executedPredicate(2, x, null);
                if (x.key < min) {
                    executedPredicate(4, x, y);
                    y = x;
                    min = x.key;
                } else {
                    executedPredicate(5, x, y);
                }

                x = x.sibling;
            }
            executedPredicate(3, x, y);
            return y;
        }

        private BinomialHeapNode findANodeWithKey(int value) {
            BinomialHeapNode temp = this, node = null;
            while (temp != null) {
                executedPredicate(6, temp, node);
                if (temp.key == value) {
                    executedPredicate(8, temp, node);
                    node = temp;
                    break;
                } else {
                    executedPredicate(9, temp, node);
                }

                if (temp.child == null) {
                    executedPredicate(10, temp, node);
                    temp = temp.sibling;
                } else {
                    executedPredicate(11, temp, node);
                    node = temp.child.findANodeWithKey(value);
                    if (node == null) {
                        executedPredicate(12, temp, node);
                        temp = temp.sibling;
                    } else {
                        executedPredicate(13, temp, node);
                        break;
                    }
                }
            }
            executedPredicate(7, temp, node);
            return node;
        }
        
    }

    private BinomialHeapNode Nodes;

    private int size;

    public BinomialHeap_pred() {
        Nodes = null;
        size = 0;
    }

    public String toString() {
        return Nodes != null ? Nodes.toString() : "null";
    }

    public int getSize() {
        return size;
    }

    public int findMinimum() {
        return Nodes.findMinNode().key;
    }

    private void merge(BinomialHeapNode binHeap) {
        BinomialHeapNode temp1 = Nodes, temp2 = binHeap;
        while ((temp1 != null) && (temp2 != null)) {
            executedPredicate(14, temp1, temp2);
            if (temp1.degree == temp2.degree) {
                executedPredicate(16, temp1, temp2);
                BinomialHeapNode tmp = temp2;
                temp2 = temp2.sibling;
                tmp.sibling = temp1.sibling;
                temp1.sibling = tmp;
                temp1 = tmp.sibling;
            } else {
                executedPredicate(17, temp1, temp2);
                if (temp1.degree < temp2.degree) {
                    executedPredicate(18, temp1, temp2);
                    if ((temp1.sibling == null)
                            || (temp1.sibling.degree > temp2.degree)) {
                        executedPredicate(20, temp1, temp2);
                        BinomialHeapNode tmp = temp2;
                        temp2 = temp2.sibling;
                        tmp.sibling = temp1.sibling;
                        temp1.sibling = tmp;
                        temp1 = tmp.sibling;
                    } else {
                        executedPredicate(21, temp1, temp2);
                        temp1 = temp1.sibling;
                    }
                } else {
                    executedPredicate(19, temp1, temp2);
                    BinomialHeapNode tmp = temp1;
                    temp1 = temp2;
                    temp2 = temp2.sibling;
                    temp1.sibling = tmp;
                    if (tmp == Nodes) {
                        executedPredicate(22, temp1, temp2);
                        Nodes = temp1;
                    } else {
                        executedPredicate(23, temp1, temp2);
                    }
                }
            }
        }
        executedPredicate(15, temp1, temp2);
        if (temp1 == null) {
            executedPredicate(24, temp1, temp2);
            temp1 = Nodes;
            while (temp1.sibling != null) {
                executedPredicate(26, temp1, temp2);
                temp1 = temp1.sibling;
            }
            executedPredicate(27, temp1, temp2);
            temp1.sibling = temp2;
        } else {
            executedPredicate(25, temp1, temp2);
        }
    }

    private void unionNodes(BinomialHeapNode binHeap) {
        merge(binHeap);
        BinomialHeapNode prevTemp = null, temp = Nodes, nextTemp = Nodes.sibling;
        while (nextTemp != null) {
            executedPredicate(28, temp, nextTemp);
            if ((temp.degree != nextTemp.degree)
                    || ((nextTemp.sibling != null) && (nextTemp.sibling.degree == temp.degree))) {
                executedPredicate(30, temp, nextTemp);
                prevTemp = temp;
                temp = nextTemp;
            } else {
                executedPredicate(31, temp, nextTemp);
                if (temp.key <= nextTemp.key) {
                    executedPredicate(32, temp, nextTemp);
                    temp.sibling = nextTemp.sibling;
                    nextTemp.parent = temp;
                    nextTemp.sibling = temp.child;
                    temp.child = nextTemp;
                    temp.degree++;
                } else {
                    executedPredicate(33, temp, nextTemp);
                    if (prevTemp == null) {
                        executedPredicate(34, temp, nextTemp);
                        Nodes = nextTemp;
                    } else {
                        executedPredicate(35, temp, nextTemp);
                        prevTemp.sibling = nextTemp;
                    }

                    temp.parent = nextTemp;
                    temp.sibling = nextTemp.child;
                    nextTemp.child = temp;
                    nextTemp.degree++;
                    temp = nextTemp;
                }
            }

            nextTemp = temp.sibling;
        }
        executedPredicate(29, temp, nextTemp);
    }

    public void insert(int value) {
        if (value > 0) {
            executedPredicate(36, Nodes, null);
            BinomialHeapNode temp = new BinomialHeapNode(value);
            if (Nodes == null) {
                executedPredicate(38, Nodes, temp);
                Nodes = temp;
                size = 1;
            } else {
                executedPredicate(39, Nodes, temp);
                unionNodes(temp);
                size++;
            }
        } else {
            executedPredicate(37, Nodes, null);
        }
    }

    public int extractMin() {
        if (Nodes == null) {
            executedPredicate(40, null, null);
            return -1;
        } else {
            executedPredicate(41, Nodes, null);
        }

        BinomialHeapNode temp = Nodes, prevTemp = null;
        BinomialHeapNode minNode = Nodes.findMinNode();
        while (temp.key != minNode.key) {
            executedPredicate(42, temp, prevTemp);
            prevTemp = temp;
            temp = temp.sibling;
        }
        executedPredicate(43, temp, prevTemp);
        if (prevTemp == null) {
            executedPredicate(44, temp, prevTemp);
            Nodes = temp.sibling;
        } else {
            executedPredicate(45, temp, prevTemp);
            prevTemp.sibling = temp.sibling;
        }

        temp = temp.child;
        BinomialHeapNode fakeNode = temp;
        while (temp != null) {
            executedPredicate(46, temp, prevTemp);
            temp.parent = null;
            temp = temp.sibling;
        }
        executedPredicate(47, temp, prevTemp);
        if ((Nodes == null) && (fakeNode == null)) {
            executedPredicate(48, temp, prevTemp);
            size = 0;
        } else {
            executedPredicate(49, temp, prevTemp);
            if ((Nodes == null) && (fakeNode != null)) {
                executedPredicate(50, Nodes, fakeNode);
                Nodes = fakeNode.reverse(null);
                size = Nodes.getSize();
            } else {
                executedPredicate(51, Nodes, fakeNode);
                if ((Nodes != null) && (fakeNode == null)) {
                    executedPredicate(52, Nodes, fakeNode);
                    size = Nodes.getSize();
                } else {
                    executedPredicate(53, Nodes, fakeNode);
                    unionNodes(fakeNode.reverse(null));
                    size = Nodes.getSize();
                }
            }
        }

        return minNode.key;
    }

    public void decreaseKeyValue(int old_value, int new_value) {
        BinomialHeapNode temp = Nodes.findANodeWithKey(old_value);
        if (temp == null) {
            executedPredicate(54, Nodes, null);
            return;
        } else {
            executedPredicate(55, Nodes, temp);
        }

        temp.key = new_value;
        BinomialHeapNode tempParent = temp.parent;
        while ((tempParent != null) && (temp.key < tempParent.key)) {
            executedPredicate(56, temp, tempParent);
            int z = temp.key;
            temp.key = tempParent.key;
            tempParent.key = z;
            temp = tempParent;
            tempParent = tempParent.parent;
        }
        executedPredicate(57, temp, tempParent);
    }

    public void delete(int value) {
        if ((Nodes != null) && (Nodes.findANodeWithKey(value) != null)) {
            executedPredicate(58, Nodes, null);
            decreaseKeyValue(value, findMinimum() - 1);
            extractMin();
        } else {
            executedPredicate(59, null, null);
        }

    }

    public static void main(String[] Argv) {
        BinomialHeap_pred b = new BinomialHeap_pred();
        b.insert(3);
        b.insert(5);
        System.out.println("min: " + b.findMinimum());
        System.out.println("size: " + b.size);
        b.extractMin();
        System.out.println("min: " + b.findMinimum());
    }

    private static int NUM_OF_PREDICATES = 9;

    public static int numOfPredicates() {
        return NUM_OF_PREDICATES;
    }

    public static void executedPredicate(int branch_id, BinomialHeapNode n1,
            BinomialHeapNode n2) {
        int res = 0;
        int temp, temp2;

        if (n1 != null) {
            res |= 1 << 0;
            res |= (n1.child == null) ? 0 : 1 << 1;
            res |= (n1.sibling == null) ? 0 : 1 << 2;
            res |= (n1.parent == null) ? 0 : 1 << 3;
        }

        if (n2 != null) {
            res |= 1 << 4;
            res |= (n2.child == null) ? 0 : 1 << 5;
            res |= (n2.sibling == null) ? 0 : 1 << 6;
            res |= (n2.parent == null) ? 0 : 1 << 7;
        }

        if (n1 != null && n2 != null) {
            temp = n1.degree;
            temp2 = n2.degree;
            if (temp < temp2)
                res |= 1 << 8;
            else if (temp == temp2)
                res |= 2 << 8;
            else if (temp > temp2)
                res |= 3 << 8;
        }
        System.out.println("branchId=" + branch_id + "; covered predicate combination=" + res);
    }

}
