/**
 * Semi-automatically generated files used to measure predicate coverage.
 * Details can be found at http://mir.cs.illinois.edu/coverage
 */
package predicate.issta2006.bintree;

class Node {
    public int value;

    public Node left, right;

    public Node(int x) {
        value = x;
        left = null;
        right = null;
    }

    @Override
    public String toString() {
        String res = "{" + value + "["
                + (left != null ? left.toString() : null) + "]" + "["
                + (right != null ? right.toString() : null) + "]}";
        return res;
    }
}

public class BinTree_pred {

    private Node root;

    public BinTree_pred() {
        root = null;
    }

    @Override
    public String toString() {
        return root != null ? root.toString() : "null";
    }

    public void add(int x) {
        Node current = root;
        if (root == null) {
            executedPredicate(0, current, x, null, null);
            root = new Node(x);
            return;
        } else {
            executedPredicate(1, current, x, null, null);
        }

        while (current.value != x) {
            executedPredicate(2, current, x, null, null);
            if (x < current.value) {
                executedPredicate(4, current, x, null, null);
                if (current.left == null) {
                    executedPredicate(6, current, x, null, null);
                    current.left = new Node(x);
                } else {
                    executedPredicate(7, current, x, null, null);
                    current = current.left;
                }
            } else {
                executedPredicate(5, current, x, null, null);
                if (current.right == null) {
                    executedPredicate(8, current, x, null, null);
                    current.right = new Node(x);
                } else {
                    executedPredicate(9, current, x, null, null);
                    current = current.right;
                }
            }
        }
        executedPredicate(3, current, x, null, null);
    }

    public boolean find(int x) {
        Node current = root;
        while (current != null) {
            executedPredicate(10, current, x, null, null);
            if (current.value == x) {
                executedPredicate(12, current, x, null, null);
                return true;
            } else {
                executedPredicate(13, current, x, null, null);
            }

            if (x < current.value) {
                executedPredicate(14, current, x, null, null);
                current = current.left;
            } else {
                executedPredicate(15, current, x, null, null);
                current = current.right;
            }
        }
        executedPredicate(11, current, x, null, null);
        return false;
    }

    public boolean remove(int x) {
        Node current = root;
        Node parent = null;
        boolean branch = true;
        while (current != null) {
            executedPredicate(16, current, x, null, null);
            if (current.value == x) {
                executedPredicate(18, current, x, null, null);
                Node bigson = current;
                while (bigson.left != null || bigson.right != null) {
                    executedPredicate(20, current, x, bigson, parent);
                    parent = bigson;
                    if (bigson.right != null) {
                        executedPredicate(22, current, x, bigson, parent);
                        bigson = bigson.right;
                        branch = false;
                    } else {
                        executedPredicate(23, current, x, bigson, parent);
                        bigson = bigson.left;
                        branch = true;
                    }
                }
                executedPredicate(21, current, x, bigson, parent);
                if (parent != null) {
                    executedPredicate(24, current, x, bigson, parent);
                    if (branch) {
                        executedPredicate(26, current, x, bigson, parent);
                        parent.left = null;
                    } else {
                        executedPredicate(27, current, x, bigson, parent);
                        parent.right = null;
                    }
                } else {
                    executedPredicate(25, current, x, bigson, parent);
                }

                if (bigson != current) {
                    executedPredicate(28, current, x, bigson, parent);
                    current.value = bigson.value;
                } else {
                    executedPredicate(29, current, x, bigson, parent);
                }

                return true;
            } else {
                executedPredicate(19, current, x, null, parent);
            }

            parent = current;
            if (current.value > x) {
                executedPredicate(30, current, x, null, parent);
                current = current.left;
                branch = true;
            } else {
                executedPredicate(31, current, x, null, parent);
                current = current.right;
                branch = false;
            }
        }
        executedPredicate(17, current, x, null, parent);
        return false;
    }

    private static int NUM_OF_PREDICATES = 7;

    public static int numOfPredicates() {
        return NUM_OF_PREDICATES;
    }

    public int executedPredicate(int branch_id, Node n0, int x, Node n1, Node n2) {
        int res = 0;

        if (n0 != null) {
            res |= 1 << 0;
            res |= (n0.left == null) ? 0 : 1 << 1;
            res |= (n0.right == null) ? 0 : 1 << 2;
        }

        res |= (n1 == null) ? 0 : 1 << 3;

        if (n2 != null) {
            res |= 1 << 4;
            res |= (n2.left == null) ? 0 : 1 << 5;
            res |= (n2.right == null) ? 0 : 1 << 6;
        }
        return res;
    }/* BT__E */

}
