/**
 * Semi-automatically generated files used to measure predicate coverage.
 * Details can be found at http://mir.cs.illinois.edu/coverage
 */
package predicate.issta2006.treemap;

public class TreeMap_pred {

    private transient Entry root = null;

    private transient int size = 0;

    private void incrementSize() {
        size++;
    }

    private void decrementSize() {
        size--;
    }

    public TreeMap_pred() {
    }

    public int size() {
        return size;
    }

    public boolean containsKey(int key) {
        return getEntry(key) != null;
    }

    private Entry getEntry(int key) {
        Entry p = root;
        while (p != null) {
            executedPredicate(0, p);
            if (key == p.key) {
                executedPredicate(2, p);
                return p;
            } else {
                executedPredicate(3, p);
                if (key < p.key) {
                    executedPredicate(4, p);
                    p = p.left;
                } else {
                    executedPredicate(5, p);
                    p = p.right;
                }
            }

        }
        executedPredicate(1, p);
        return null;
    }

    public void put(int key) {
        Entry t = root;
        if (t == null) {
            executedPredicate(6, t);
            incrementSize();
            root = new Entry(key, null);
            return;
        } else {
            executedPredicate(7, t);
        }

        while (true) {
            executedPredicate(8, t);
            if (key == t.key) {
                executedPredicate(9, t);
                return;
            } else {
                executedPredicate(10, t);
                if (key < t.key) {
                    executedPredicate(11, t);
                    if (t.left != null) {
                        executedPredicate(13, t);
                        t = t.left;
                    } else {
                        executedPredicate(14, t);
                        incrementSize();
                        t.left = new Entry(key, t);
                        fixAfterInsertion(t.left);
                        return;
                    }

                } else {
                    executedPredicate(12, t);
                    if (t.right != null) {
                        executedPredicate(15, t);
                        t = t.right;
                    } else {
                        executedPredicate(16, t);
                        incrementSize();
                        t.right = new Entry(key, t);
                        fixAfterInsertion(t.right);
                        return;
                    }

                }
            }

        }
    }

    public void remove(int key) {
        Entry p = getEntry(key);
        if (p == null) {
            executedPredicate(17, p);
            return;
        } else {
            executedPredicate(18, p);
        }

        deleteEntry(p);
        return;
    }

    @Override
    public String toString() {
        String res = "";
        if (root != null)
            res = root.toString();
        return res;
    }

    public String concreteString(int max_level) {
        String res = "";
        if (root != null)
            res = root.concreteString(max_level, 0);
        return res;
    }

    private final static boolean RED = false;

    private final static boolean BLACK = true;

    static class Entry {

        int key;

        Entry left = null;

        Entry right = null;

        Entry parent;

        boolean color = BLACK;

        Entry(int key, Entry parent) {
            this.key = key;
            this.parent = parent;
        }

        Entry(int key, Entry left, Entry right, Entry parent, boolean color) {
            this.key = key;
            this.left = left;
            this.right = right;
            this.parent = parent;
            this.color = color;
        }

        public int getKey() {
            return key;
        }

        @Override
        public String toString() {
            String res = "{ " + (color == BLACK ? "B" : "R") + " ";
            if (left == null)
                res += "null";
            else
                res += left.toString();
            res += " ";
            if (right == null)
                res += "null";
            else
                res += right.toString();
            res += " }";
            return res;
        }

        public String concreteString(int max_level, int cur_level) {
            String res;
            if (cur_level == max_level) {
                res = "{ subtree }";
            } else {
                res = "{ " + (color == BLACK ? "B" : "R") + key + " ";
                if (left == null)
                    res += "null";
                else
                    res += left.concreteString(max_level, cur_level + 1);
                res += " ";
                if (right == null)
                    res += "null";
                else
                    res += right.concreteString(max_level, cur_level + 1);
                res += " }";
            }

            return res;
        }

    }

    private Entry successor(Entry t) {
        if (t == null) {
            executedPredicate(19, t);
            return null;
        } else {
            executedPredicate(20, t);
            if (t.right != null) {
                executedPredicate(21, t);
                Entry p = t.right;
                while (p.left != null) {
                    executedPredicate(23, t);
                    p = p.left;
                }
                executedPredicate(24, t);
                return p;
            } else {
                executedPredicate(22, t);
                Entry p = t.parent;
                Entry ch = t;
                while (p != null && ch == p.right) {
                    executedPredicate(25, t);
                    ch = p;
                    p = p.parent;
                }
                executedPredicate(26, t);
                return p;
            }
        }

    }

    private static boolean colorOf(Entry p) {
        return (p == null ? BLACK : p.color);
    }

    private static Entry parentOf(Entry p) {
        return (p == null ? null : p.parent);
    }

    private static void setColor(Entry p, boolean c) {
        if (p != null)
            p.color = c;
    }

    private static Entry leftOf(Entry p) {
        return (p == null) ? null : p.left;
    }

    private static Entry rightOf(Entry p) {
        return (p == null) ? null : p.right;
    }

    private void rotateLeft(Entry p) {
        Entry r = p.right;
        p.right = r.left;
        if (r.left != null) {
            executedPredicate(27, p);
            r.left.parent = p;
        } else {
            executedPredicate(28, p);
        }

        r.parent = p.parent;
        if (p.parent == null) {
            executedPredicate(29, p);
            root = r;
        } else {
            executedPredicate(30, p);
            if (p.parent.left == p) {
                executedPredicate(31, p);
                p.parent.left = r;
            } else {
                executedPredicate(32, p);
                p.parent.right = r;
            }
        }

        r.left = p;
        p.parent = r;
    }

    private void rotateRight(Entry p) {
        Entry l = p.left;
        p.left = l.right;
        if (l.right != null) {
            executedPredicate(33, p);
            l.right.parent = p;
        } else {
            executedPredicate(34, p);
        }

        l.parent = p.parent;
        if (p.parent == null) {
            executedPredicate(35, p);
            root = l;
        } else {
            executedPredicate(36, p);
            if (p.parent.right == p) {
                executedPredicate(37, p);
                p.parent.right = l;
            } else {
                executedPredicate(38, p);
                p.parent.left = l;
            }
        }

        l.right = p;
        p.parent = l;
    }

    private void fixAfterInsertion(Entry x) {
        x.color = RED;
        while (x != null && x != root && x.parent.color == RED) {
            executedPredicate(39, x);
            if (parentOf(x) == leftOf(parentOf(parentOf(x)))) {
                executedPredicate(41, x);
                Entry y = rightOf(parentOf(parentOf(x)));
                if (colorOf(y) == RED) {
                    executedPredicate(43, x);
                    setColor(parentOf(x), BLACK);
                    setColor(y, BLACK);
                    setColor(parentOf(parentOf(x)), RED);
                    x = parentOf(parentOf(x));
                } else {
                    executedPredicate(44, x);
                    if (x == rightOf(parentOf(x))) {
                        executedPredicate(45, x);
                        x = parentOf(x);
                        rotateLeft(x);
                    } else {
                        executedPredicate(46, x);
                    }

                    setColor(parentOf(x), BLACK);
                    setColor(parentOf(parentOf(x)), RED);
                    if (parentOf(parentOf(x)) != null) {
                        executedPredicate(47, x);
                        rotateRight(parentOf(parentOf(x)));
                    } else {
                        executedPredicate(48, x);
                    }
                }
            } else {
                executedPredicate(42, x);
                Entry y = leftOf(parentOf(parentOf(x)));
                if (colorOf(y) == RED) {
                    executedPredicate(49, x);
                    setColor(parentOf(x), BLACK);
                    setColor(y, BLACK);
                    setColor(parentOf(parentOf(x)), RED);
                    x = parentOf(parentOf(x));
                } else {
                    executedPredicate(50, x);
                    if (x == leftOf(parentOf(x))) {
                        executedPredicate(51, x);
                        x = parentOf(x);
                        rotateRight(x);
                    } else {
                        executedPredicate(52, x);
                    }

                    setColor(parentOf(x), BLACK);
                    setColor(parentOf(parentOf(x)), RED);
                    if (parentOf(parentOf(x)) != null) {
                        executedPredicate(53, x);
                        rotateLeft(parentOf(parentOf(x)));
                    } else {
                        executedPredicate(54, x);
                    }
                }
            }
        }
        executedPredicate(40, x);
        root.color = BLACK;
    }

    private void deleteEntry(Entry p) {
        decrementSize();
        if (p.left != null && p.right != null) {
            executedPredicate(55, p);
            Entry s = successor(p);
            swapPosition(s, p);
        } else {
            executedPredicate(56, p);
        }

        Entry replacement = (p.left != null ? p.left : p.right);
        if (replacement != null) {
            executedPredicate(57, p);
            replacement.parent = p.parent;
            if (p.parent == null) {
                executedPredicate(59, p);
                root = replacement;
            } else {
                executedPredicate(62, p);
                if (p == p.parent.left) {
                    executedPredicate(61, p);
                    p.parent.left = replacement;
                } else {
                    executedPredicate(62, p);
                    p.parent.right = replacement;
                }
            }

            p.left = p.right = p.parent = null;
            if (p.color == BLACK) {
                executedPredicate(63, p);
                fixAfterDeletion(replacement);
            } else {
                executedPredicate(64, p);
            }
        } else {
            executedPredicate(58, p);
            if (p.parent == null) {
                executedPredicate(65, p);
                root = null;
            } else {
                executedPredicate(66, p);
                if (p.color == BLACK) {
                    executedPredicate(67, p);
                    fixAfterDeletion(p);
                } else {
                    executedPredicate(68, p);
                }

                if (p.parent != null) {
                    executedPredicate(69, p);
                    if (p == p.parent.left) {
                        executedPredicate(71, p);
                        p.parent.left = null;
                    } else {
                        executedPredicate(72, p);
                        if (p == p.parent.right) {
                            executedPredicate(73, p);
                            p.parent.right = null;
                        } else {
                            executedPredicate(74, p);
                        }
                    }

                    p.parent = null;
                } else {
                    executedPredicate(70, p);
                }
            }
        }

    }

    private void fixAfterDeletion(Entry x) {
        while (x != root && colorOf(x) == BLACK) {
            executedPredicate(75, x);
            if (x == leftOf(parentOf(x))) {
                executedPredicate(77, x);
                Entry sib = rightOf(parentOf(x));
                if (colorOf(sib) == RED) {
                    executedPredicate(79, x);
                    setColor(sib, BLACK);
                    setColor(parentOf(x), RED);
                    rotateLeft(parentOf(x));
                    sib = rightOf(parentOf(x));
                } else {
                    executedPredicate(80, x);
                }

                if (colorOf(leftOf(sib)) == BLACK
                        && colorOf(rightOf(sib)) == BLACK) {
                    executedPredicate(81, x);
                    setColor(sib, RED);
                    x = parentOf(x);
                } else {
                    executedPredicate(82, x);
                    if (colorOf(rightOf(sib)) == BLACK) {
                        executedPredicate(83, x);
                        setColor(leftOf(sib), BLACK);
                        setColor(sib, RED);
                        rotateRight(sib);
                        sib = rightOf(parentOf(x));
                    } else {
                        executedPredicate(84, x);
                    }

                    setColor(sib, colorOf(parentOf(x)));
                    setColor(parentOf(x), BLACK);
                    setColor(rightOf(sib), BLACK);
                    rotateLeft(parentOf(x));
                    x = root;
                }
            } else {
                executedPredicate(78, x);
                Entry sib = leftOf(parentOf(x));
                if (colorOf(sib) == RED) {
                    executedPredicate(85, x);
                    setColor(sib, BLACK);
                    setColor(parentOf(x), RED);
                    rotateRight(parentOf(x));
                    sib = leftOf(parentOf(x));
                } else {
                    executedPredicate(86, x);
                }

                if (colorOf(rightOf(sib)) == BLACK
                        && colorOf(leftOf(sib)) == BLACK) {
                    executedPredicate(87, x);
                    setColor(sib, RED);
                    x = parentOf(x);
                } else {
                    executedPredicate(88, x);
                    if (colorOf(leftOf(sib)) == BLACK) {
                        executedPredicate(89, x);
                        setColor(rightOf(sib), BLACK);
                        setColor(sib, RED);
                        rotateLeft(sib);
                        sib = leftOf(parentOf(x));
                    } else {
                        executedPredicate(90, x);
                    }

                    setColor(sib, colorOf(parentOf(x)));
                    setColor(parentOf(x), BLACK);
                    setColor(leftOf(sib), BLACK);
                    rotateRight(parentOf(x));
                    x = root;
                }
            }
        }
        executedPredicate(76, x);
        setColor(x, BLACK);
    }

    private void swapPosition(Entry x, Entry y) {
        Entry px = x.parent, lx = x.left, rx = x.right;
        Entry py = y.parent, ly = y.left, ry = y.right;
        boolean xWasLeftChild = px != null && x == px.left;
        boolean yWasLeftChild = py != null && y == py.left;
        if (x == py) {
            executedPredicate(91, x);
            x.parent = y;
            if (yWasLeftChild) {
                executedPredicate(93, x);
                y.left = x;
                y.right = rx;
            } else {
                executedPredicate(94, x);
                y.right = x;
                y.left = lx;
            }
        } else {
            executedPredicate(92, x);
            x.parent = py;
            if (py != null) {
                executedPredicate(95, x);
                if (yWasLeftChild) {
                    executedPredicate(97, x);
                    py.left = x;
                } else {
                    executedPredicate(98, x);
                    py.right = x;
                }

            } else {
                executedPredicate(96, x);
            }

            y.left = lx;
            y.right = rx;
        }

        if (y == px) {
            executedPredicate(89, x);
            y.parent = x;
            if (xWasLeftChild) {
                executedPredicate(91, x);
                x.left = y;
                x.right = ry;
            } else {
                executedPredicate(92, x);
                x.right = y;
                x.left = ly;
            }
        } else {
            executedPredicate(90, x);
            y.parent = px;
            if (px != null) {
                executedPredicate(93, x);
                if (xWasLeftChild) {
                    executedPredicate(95, x);
                    px.left = y;
                } else {
                    executedPredicate(96, x);
                    px.right = y;
                }

            } else {
                executedPredicate(94, x);
            }

            x.left = ly;
            x.right = ry;
        }

        if (x.left != null) {
            executedPredicate(97, x);
            x.left.parent = x;
        } else {
            executedPredicate(98, x);
        }

        if (x.right != null) {
            executedPredicate(99, x);
            x.right.parent = x;
        } else {
            executedPredicate(100, x);
        }

        if (y.left != null) {
            executedPredicate(101, x);
            y.left.parent = y;
        } else {
            executedPredicate(102, x);
        }

        if (y.right != null) {
            executedPredicate(103, x);
            y.right.parent = y;
        } else {
            executedPredicate(104, x);
        }

        boolean c = x.color;
        x.color = y.color;
        y.color = c;
        if (root == x) {
            executedPredicate(105, x);
            root = y;
        } else {
            executedPredicate(106, x);
            if (root == y) {
                executedPredicate(107, x);
                root = x;
            } else {
                executedPredicate(108, x);
            }
        }
    }

    private static int NUM_OF_PREDICATES = 6;

    public static int numOfPredicates() {
        return NUM_OF_PREDICATES;
    }

    public void executedPredicate(int branch_id, Entry n) {
        int res = 0;
        if (n != null) {
            res |= 1 << 0;
            res |= (n.left == null) ? 0 : 1 << 1;
            res |= (n.right == null) ? 0 : 1 << 2;
            res |= (n.parent == null) ? 0 : 1 << 3;
            res |= (n.color == RED) ? 0 : 1 << 4;
            res |= (n == root) ? 0 : 1 << 5;
        }
        System.out.println("branchId=" + branch_id + "; covered predicate combination=" + res);
    }

}
