/**
 * Semi-automatically generated files used to measure predicate coverage.
 * Details can be found at http://mir.cs.illinois.edu/coverage
 */
package predicate.taco.avltree;

public class AvlTree_pred {

    private static AvlNode doubleWithLeftChild(final AvlNode k3) {
        k3.left = AvlTree_pred.rotateWithRightChild(k3.left);
        return AvlTree_pred.rotateWithLeftChild(k3);
    }

    private static AvlNode doubleWithRightChild(final AvlNode k1) {
        k1.right = AvlTree_pred.rotateWithLeftChild(k1.right);
        return AvlTree_pred.rotateWithRightChild(k1);
    }

    private static int height(final AvlNode t) {
        return t == null ? -1 : t.height;
    }

    private static int max(final int lhs, final int rhs) {
        return lhs > rhs ? lhs : rhs;
    }

    private static AvlNode rotateWithLeftChild(final AvlNode k2) {
        final AvlNode k1 = k2.left;
        k2.left = k1.right;
        k1.right = k2;
        k2.height = AvlTree_pred.max(AvlTree_pred.height(k2.left),
                AvlTree_pred.height(k2.right)) + 1;
        k1.height = AvlTree_pred.max(AvlTree_pred.height(k1.left), k2.height) + 1;
        return k1;
    }

    private static AvlNode rotateWithRightChild(final AvlNode k1) {
        final AvlNode k2 = k1.right;
        k1.right = k2.left;
        k2.left = k1;
        k1.height = AvlTree_pred.max(AvlTree_pred.height(k1.left),
                AvlTree_pred.height(k1.right)) + 1;
        k2.height = AvlTree_pred.max(AvlTree_pred.height(k2.right), k1.height) + 1;
        return k2;
    }

    private AvlNode root;

    public AvlTree_pred() {
        this.root = null;
    }

    @Override
    public String toString() {
        return root != null ? root.toString() : "null";
    }

    boolean balanced() {
        return balanced(this.root);
    }

    private boolean balanced(final AvlNode an) {
        if (an == null) {
            executedPredicate(0, null);
            return true;
        } else {
            executedPredicate(1, an);
        }

        final int lh = AvlTree_pred.height(an.left);
        final int rh = AvlTree_pred.height(an.right);
        return ((lh == rh) || (lh == rh + 1) || (lh + 1 == rh))
                && balanced(an.left) && balanced(an.right);
    }

    private int elementAt(final AvlNode t) {
        return t == null ? -1 : t.element;
    }

    public int find(final int x) {
        return elementAt(find(x, this.root));
    }

    public AvlNode findNode(final int x) {
        return find(x, this.root);
    }

    private AvlNode find(final int x, final AvlNode arg) {
        AvlNode t = arg;
        while (t != null) {
            executedPredicate(2, t);
            if (x < t.element) {
                executedPredicate(4, t);
                t = t.left;
            } else {
                executedPredicate(5, t);
                if (x > t.element) {
                    executedPredicate(6, t);
                    t = t.right;
                } else {
                    executedPredicate(7, t);
                    return t;
                }
            }

        }
        executedPredicate(3, t);
        return null;
    }

    public int findMax() {
        return elementAt(findMax(this.root));
    }

    public AvlNode fmax() {
        return findMax(this.root);
    }

    private AvlNode findMax(final AvlNode arg) {
        AvlNode t = arg;
        if (t == null) {
            executedPredicate(8, null);
            return t;
        } else {
            executedPredicate(9, t);
        }

        while (t.right != null) {
            executedPredicate(10, t.right);
            t = t.right;
        }
        executedPredicate(11, t);
        return t;
    }

    public int findMin() {
        return elementAt(findMin(this.root));
    }

    private AvlNode findMin(AvlNode t) {
        if (t == null) {
            executedPredicate(12, t);
            return t;
        } else {
            executedPredicate(13, t);
        }

        while (t.left != null) {
            executedPredicate(14, t.left);
            t = t.left;
        }
        executedPredicate(15, t);
        return t;
    }

    public void insertElem(final int x) {
        this.root = insert(x, this.root);
    }

    private AvlNode insert(final int x, final AvlNode arg) {
        AvlNode t = arg;
        if (t == null) {
            executedPredicate(16, t);
            t = new AvlNode(x, null, null);
        } else {
            executedPredicate(17, t);
            if (x < t.element) {
                executedPredicate(18, t);
                t.left = insert(x, t.left);
                if (AvlTree_pred.height(t.left) - AvlTree_pred.height(t.right) == 2) {
                    executedPredicate(20, t.left);
                    if (x < t.left.element) {
                        executedPredicate(22, t.left);
                        t = AvlTree_pred.rotateWithLeftChild(t);
                    } else {
                        executedPredicate(23, t.left);
                        t = AvlTree_pred.doubleWithLeftChild(t);
                    }

                } else {
                    executedPredicate(21, t);
                }
            } else {
                executedPredicate(19, t);
                if (x > t.element) {
                    executedPredicate(24, t);
                    t.right = insert(x, t.right);
                    if (AvlTree_pred.height(t.right)
                            - AvlTree_pred.height(t.left) == 2) {
                        executedPredicate(26, t.right);
                        if (x > t.right.element) {
                            executedPredicate(28, t.right);
                            t = AvlTree_pred.rotateWithRightChild(t);
                        } else {
                            executedPredicate(29, t.right);
                            t = AvlTree_pred.doubleWithRightChild(t);
                        }

                    } else {
                        executedPredicate(27, t);
                    }
                } else {
                    executedPredicate(25, t);
                }
            }
        }

        t.height = AvlTree_pred.max(AvlTree_pred.height(t.left),
                AvlTree_pred.height(t.right)) + 1;
        return t;
    }

    private AvlNode insert_0(final int x, final AvlNode arg) {
        AvlNode t = arg;
        if (t == null) {
            executedPredicate(30, t);
            t = new AvlNode(x, null, null);
        } else {
            executedPredicate(31, t);
            if (x < t.element) {
                executedPredicate(32, t);
                t.left = insert_1(x, t.left);
                if (AvlTree_pred.height(t.left) - AvlTree_pred.height(t.right) == 2) {
                    executedPredicate(34, t);
                    if (x < t.left.element) {
                        executedPredicate(36, t);
                        t = AvlTree_pred.rotateWithLeftChild(t);
                    } else {
                        executedPredicate(37, t);
                        t = AvlTree_pred.doubleWithLeftChild(t);
                    }

                } else {
                    executedPredicate(35, t);
                }
            } else {
                executedPredicate(33, t);
                if (x > t.element) {
                    executedPredicate(38, t);
                    t.right = insert_1(x, t.right);
                    if (AvlTree_pred.height(t.right)
                            - AvlTree_pred.height(t.left) == 2) {
                        executedPredicate(40, t);
                        if (x > t.right.element) {
                            executedPredicate(42, t);
                            t = AvlTree_pred.rotateWithRightChild(t);
                        } else {
                            executedPredicate(43, t);
                            t = AvlTree_pred.doubleWithRightChild(t);
                        }

                    } else {
                        executedPredicate(41, t);
                    }

                } else {
                    executedPredicate(39, t);
                }
            }
        }

        t.height = AvlTree_pred.max(AvlTree_pred.height(t.left),
                AvlTree_pred.height(t.right)) + 1;
        return t;
    }

    private AvlNode insert_1(final int x, final AvlNode arg) {
        AvlNode t = arg;
        if (t == null) {
            executedPredicate(44, t);
            t = new AvlNode(x, null, null);
        } else {
            executedPredicate(45, t);
            if (x < t.element) {
                executedPredicate(46, t);
                t.left = insert_2(x, t.left);
                if (AvlTree_pred.height(t.left) - AvlTree_pred.height(t.right) == 2) {
                    executedPredicate(48, t);
                    if (x < t.left.element) {
                        executedPredicate(50, t);
                        t = AvlTree_pred.rotateWithLeftChild(t);
                    } else {
                        executedPredicate(51, t);
                        t = AvlTree_pred.doubleWithLeftChild(t);
                    }

                } else {
                    executedPredicate(49, t);
                }
            } else {
                executedPredicate(47, t);
                if (x > t.element) {
                    executedPredicate(52, t);
                    t.right = insert_2(x, t.right);
                    if (AvlTree_pred.height(t.right)
                            - AvlTree_pred.height(t.left) == 2) {
                        executedPredicate(54, t);
                        if (x > t.right.element) {
                            executedPredicate(56, t);
                            t = AvlTree_pred.rotateWithRightChild(t);
                        } else {
                            executedPredicate(57, t);
                            t = AvlTree_pred.doubleWithRightChild(t);
                        }

                    } else {
                        executedPredicate(55, t);
                    }
                } else {
                    executedPredicate(53, t);
                }
            }
        }

        t.height = AvlTree_pred.max(AvlTree_pred.height(t.left),
                AvlTree_pred.height(t.right)) + 1;
        return t;
    }

    private AvlNode insert_2(final int x, final AvlNode arg) {
        AvlNode t = arg;
        if (t == null) {
            executedPredicate(58, t);
            t = new AvlNode(x, null, null);
        } else {
            executedPredicate(59, t);
            if (x < t.element) {
                executedPredicate(60, t);
                t.left = insert_3(x, t.left);
                if (AvlTree_pred.height(t.left) - AvlTree_pred.height(t.right) == 2) {
                    executedPredicate(62, t.left);
                    if (x < t.left.element) {
                        executedPredicate(64, t.left);
                        t = AvlTree_pred.rotateWithLeftChild(t);
                    } else {
                        executedPredicate(65, t.left);
                        t = AvlTree_pred.doubleWithLeftChild(t);
                    }
                } else {
                    executedPredicate(63, t);
                }
            } else {
                executedPredicate(61, t);
                if (x > t.element) {
                    executedPredicate(66, t);
                    t.right = insert_3(x, t.right);
                    if (AvlTree_pred.height(t.right)
                            - AvlTree_pred.height(t.left) == 2) {
                        executedPredicate(68, t.right);
                        if (x > t.right.element) {
                            executedPredicate(70, t.right);
                            t = AvlTree_pred.rotateWithRightChild(t);
                        } else {
                            executedPredicate(71, t.right);
                            t = AvlTree_pred.doubleWithRightChild(t);
                        }
                    } else {
                        executedPredicate(69, t);
                    }
                } else {
                    executedPredicate(67, t);
                }
            }
        }

        t.height = AvlTree_pred.max(AvlTree_pred.height(t.left),
                AvlTree_pred.height(t.right)) + 1;
        return t;
    }

    private AvlNode insert_3(final int x, final AvlNode arg) {
        AvlNode t = arg;
        if (t == null) {
            executedPredicate(72, t);
            t = new AvlNode(x, null, null);
        } else {
            executedPredicate(73, t);
            if (x < t.element) {
                executedPredicate(74, t);
                t.left = insert_4(x, t.left);
                if (AvlTree_pred.height(t.left) - AvlTree_pred.height(t.right) == 2) {
                    executedPredicate(76, t);
                    if (x < t.left.element) {
                        executedPredicate(78, t.left);
                        t = AvlTree_pred.rotateWithLeftChild(t);
                    } else {
                        executedPredicate(79, t.left);
                        t = AvlTree_pred.doubleWithLeftChild(t);
                    }
                } else {
                    executedPredicate(77, t);
                }
            } else {
                executedPredicate(75, t);
                if (x > t.element) {
                    executedPredicate(80, t);
                    t.right = insert_4(x, t.right);
                    if (AvlTree_pred.height(t.right)
                            - AvlTree_pred.height(t.left) == 2) {
                        executedPredicate(82, t);
                        if (x > t.right.element) {
                            executedPredicate(84, t);
                            t = AvlTree_pred.rotateWithRightChild(t);
                        } else {
                            executedPredicate(85, t);
                            t = AvlTree_pred.doubleWithRightChild(t);
                        }
                    } else {
                        executedPredicate(83, t);
                    }
                } else {
                    executedPredicate(81, t);
                }
            }
        }

        t.height = AvlTree_pred.max(AvlTree_pred.height(t.left),
                AvlTree_pred.height(t.right)) + 1;
        return t;
    }

    private AvlNode insert_4(final int x, final AvlNode arg) {
        AvlNode t = arg;
        if (t == null) {
            executedPredicate(86, null);
            t = new AvlNode(x, null, null);
        } else {
            executedPredicate(87, t);
            if (x < t.element) {
                executedPredicate(88, t);
                throw new RuntimeException();
            } else {
                executedPredicate(89, t);
                if (x > t.element) {
                    executedPredicate(90, t);
                    throw new RuntimeException();
                } else {
                    executedPredicate(91, t);
                }
            }
        }

        t.height = AvlTree_pred.max(AvlTree_pred.height(t.left),
                AvlTree_pred.height(t.right)) + 1;
        return t;
    }

    public boolean isEmpty() {
        return this.root == null;
    }

    public void makeEmpty() {
        this.root = null;
    }

    boolean maxElement(final int max) {
        return maxElement(max, this.root);
    }

    private boolean maxElement(final int max, final AvlNode t) {
        if (t == null) {
            executedPredicate(92, t);
            return true;
        } else {
            executedPredicate(93, t);
        }

        if (max < t.element) {
            executedPredicate(94, t);
            return false;
        } else {
            executedPredicate(95, t);
        }

        return maxElement(max, t.left) && maxElement(max, t.right);
    }

    boolean minElement(final int min) {
        return minElement(min, this.root);
    }

    private boolean minElement(final int min, final AvlNode t) {
        if (t == null) {
            executedPredicate(96, null);
            return true;
        } else {
            executedPredicate(97, t);
        }

        if (min > t.element) {
            executedPredicate(98, t);
            return false;
        } else {
            executedPredicate(99, t);
        }

        return minElement(min, t.left) && minElement(min, t.right);
    }

    public void remove(final int x) {
    }

    boolean wellFormed() {
        return wellFormed(this.root);
    }

    private int Math_max(int l, int r) {
        return (l > r ? l : r);
    }

    private boolean wellFormed(final AvlNode an) {
        if (an == null) {
            executedPredicate(100, null);
            return true;
        } else {
            executedPredicate(101, an);
        }

        if (AvlTree_pred.height(an) != Math_max(AvlTree_pred.height(an.left),
                AvlTree_pred.height(an.right)) + 1) {
            executedPredicate(102, an);
            return false;
        } else {
            executedPredicate(103, an);
        }

        return wellFormed(an.left) && wellFormed(an.right);
    }

    private static int NUM_OF_PREDICATES = 4;

    public static int numOfPredicates() {
        return NUM_OF_PREDICATES;
    }

    public void executedPredicate(int branch_id, AvlNode n) {
        int res = 0;
        if (n != null) {
            res |= 1 << 0;
            res |= (n.left == null) ? 0 : 1 << 1;
            res |= (n.right == null) ? 0 : 1 << 2;
            res |= (n == root) ? 0 : 1 << 3;
        }
        System.out.println("branchId=" + branch_id + "; covered predicate combination=" + res);
    }

}
