/**
 * Semi-automatically generated files used to measure predicate coverage.
 * Details can be found at http://mir.cs.illinois.edu/coverage
 */
package predicate.taco.cachelist;

public class NodeCachingLinkedList_pred {

    public transient LinkedListNode header;
    protected transient int size;
    protected transient int modCount;

    protected final int DEFAULT_MAXIMUM_CACHE_SIZE = 20;

    protected transient LinkedListNode firstCachedNode;

    protected transient int cacheSize;

    protected int maximumCacheSize;

    protected LinkedListNode createHeaderNode() {
        return new LinkedListNode();
    }

    public NodeCachingLinkedList_pred() {
        header = createHeaderNode();
        size = 0;
        cacheSize = 0;
        firstCachedNode = null;
        maximumCacheSize = DEFAULT_MAXIMUM_CACHE_SIZE;
    }

    @Override
    public String toString() {
        if (header == null) {
            executedPredicate(0, null);
            return "null";
        } else {
            executedPredicate(1, null);
            LinkedListNode c = header;
            String s = c.toString();
            while (c.next != header) {
                executedPredicate(2, null);
                c = c.next;
                s += ":" + c.toString();
            }
            executedPredicate(3, null);
            return s;
        }

    }

    protected int getMaximumCacheSize() {
        return maximumCacheSize;
    }

    protected void setMaximumCacheSize(int maximumCacheSize) {
        this.maximumCacheSize = maximumCacheSize;
        shrinkCacheToMaximumSize();
    }

    protected void shrinkCacheToMaximumSize() {
        while (cacheSize > maximumCacheSize) {
            executedPredicate(4, firstCachedNode);
            getNodeFromCache();
        }
        executedPredicate(5, firstCachedNode);
    }

    protected LinkedListNode getNodeFromCache() {
        if (cacheSize == 0) {
            executedPredicate(6, null);
            return null;
        } else {
            executedPredicate(7, firstCachedNode);
        }

        LinkedListNode cachedNode = firstCachedNode;
        firstCachedNode = cachedNode.next;
        cachedNode.next = null;
        cacheSize--;
        return cachedNode;
    }

    protected boolean isCacheFull() {
        return cacheSize >= maximumCacheSize;
    }

    protected void addNodeToCache(LinkedListNode node) {
        if (isCacheFull()) {
            executedPredicate(8, node);
            return;
        } else {
            executedPredicate(9, node);
        }

        LinkedListNode nextCachedNode = firstCachedNode;
        node.previous = null;
        node.next = nextCachedNode;
        node.setValue(null);
        firstCachedNode = node;
        cacheSize++;
    }

    protected LinkedListNode createNode(Object value) {
        LinkedListNode cachedNode = getNodeFromCache();
        if (cachedNode == null) {
            executedPredicate(10, null);
            return super_createNode(value);
        } else {
            executedPredicate(11, cachedNode);
            cachedNode.setValue(value);
            return cachedNode;
        }

    }

    private void super_removeNode(LinkedListNode node) {
        node.previous.next = node.next;
        node.next.previous = node.previous;
        size--;
        modCount++;
    }

    protected void removeNode(LinkedListNode node) {
        super_removeNode(node);
        addNodeToCache(node);
    }

    protected void removeAllNodes() {
        int numberOfNodesToCache = Math_min(size, maximumCacheSize - cacheSize);
        LinkedListNode node = header.next;
        for (int currentIndex = 0; currentIndex < numberOfNodesToCache; currentIndex++) {
            executedPredicate(12, node);
            LinkedListNode oldNode = node;
            node = node.next;
            addNodeToCache(oldNode);
        }
        executedPredicate(13, node);

        super_removeAllNodes();
    }

    private int Math_min(int left, int right) {
        return left < right ? left : right;
    }

    private LinkedListNode super_createNode(Object value) {
        return new LinkedListNode(value);
    }

    private void super_removeAllNodes() {
        header.next = header;
        header.previous = header;
        size = 0;
        modCount++;
    }

    public boolean remove(Object value) {
        for (LinkedListNode node = header.next; node != header; node = node.next) {
            executedPredicate(14, node);
            if (isEqualValue(node.getValue(), value)) {
                executedPredicate(16, node);
                removeNode(node);
                return true;
            } else {
                executedPredicate(17, node);
            }

        }
        executedPredicate(15, firstCachedNode);

        return false;
    }

    protected boolean isEqualValue(Object value1, Object value2) {
        return (value1 == value2 || (value1 == null ? false : value1
                .equals(value2)));
    }

    public boolean add(Object value) {
        addLast(value);
        return true;
    }

    public boolean addLast(Object o) {
        addNodeBefore(header, o);
        return true;
    }

    protected void addNodeBefore(LinkedListNode node, Object value) {
        LinkedListNode newNode = createNode(value);
        addNode(newNode, node);
    }

    protected void addNode(LinkedListNode nodeToInsert,
            LinkedListNode insertBeforeNode) {
        nodeToInsert.next = insertBeforeNode;
        nodeToInsert.previous = insertBeforeNode.previous;
        insertBeforeNode.previous.next = nodeToInsert;
        insertBeforeNode.previous = nodeToInsert;
        size++;
        modCount++;
    }

    public boolean contains(Object arg) {
        return indexOf(arg) != -1;
    }

    public int indexOf(Object value) {
        int i = 0;
        for (LinkedListNode node = header.next; node != header; node = node.next) {
            executedPredicate(18, node);
            if (isEqualValue(node.getValue(), value)) {
                executedPredicate(20, node);
                return i;
            } else {
                executedPredicate(21, node);
            }

            i++;
        }
        executedPredicate(19, firstCachedNode);

        return -1;
    }

    public Object removeIndex(int index) {
        LinkedListNode node = getNode(index, false);
        Object oldValue = node.getValue();
        removeNode(node);
        return oldValue;
    }

    protected LinkedListNode getNode(int index, boolean endMarkerAllowed)
            throws RuntimeException {
        if (index < 0) {
            executedPredicate(22, firstCachedNode);
            throw new RuntimeException("Couldn't get the node: " + "index ("
                    + index + ") less than zero.");
        } else {
            executedPredicate(23, firstCachedNode);
        }

        if (!endMarkerAllowed && index == size) {
            executedPredicate(24, firstCachedNode);
            throw new RuntimeException("Couldn't get the node: " + "index ("
                    + index + ") is the size of the list.");
        } else {
            executedPredicate(25, firstCachedNode);
        }

        if (index > size) {
            executedPredicate(26, firstCachedNode);
            throw new IndexOutOfBoundsException("Couldn't get the node: "
                    + "index (" + index + ") greater than the size of the "
                    + "list (" + size + ").");
        } else {
            executedPredicate(27, firstCachedNode);
        }

        LinkedListNode node;
        if (index < (size / 2)) {
            executedPredicate(28, firstCachedNode);
            node = header.next;
            for (int currentIndex = 0; currentIndex < index; currentIndex++) {
                executedPredicate(30, node);
                node = node.next;
            }
            executedPredicate(31, node);

        } else {
            executedPredicate(29, firstCachedNode);
            node = header;
            for (int currentIndex = size; currentIndex > index; currentIndex--) {
                executedPredicate(32, node);
                node = node.previous;
            }
            executedPredicate(33, node);

        }

        return node;
    }

    private static int NUM_OF_PREDICATES = 4;

    public static int numOfPredicates() {
        return NUM_OF_PREDICATES;
    }

    public void executedPredicate(int branch_id, LinkedListNode n) {
        int res = 0;
        if (n != null) {
            res |= 1 << 0;
            res |= (n.previous == null) ? 0 : 1 << 1;
            res |= (n.next == null) ? 0 : 1 << 2;
            res |= (n == header) ? 0 : 1 << 3;
        }
        System.out.println("branchId=" + branch_id + "; covered predicate combination=" + res);
    }

}
