/**
 * Semi-automatically generated files used to measure predicate coverage.
 * Details can be found at http://mir.cs.illinois.edu/coverage
 */
package predicate.taco.linkedlist;

public class LinkedList_pred {

    public transient LinkedListNode header;

    protected transient int size;

    protected transient int modCount;

    public LinkedList_pred() {
        init();
        this.size = 0;
    }

    @Override
    public String toString() {
        if (header == null) {
            executedPredicate(0, null);
            return "null";
        } else {
            executedPredicate(1, null);
            LinkedListNode c = header;
            String s = c.toString();
            while (c.next != header) {
                executedPredicate(2, null);
                c = c.next;
                s += ":" + c.toString();
            }
            executedPredicate(3, null);
            return s;
        }
    }

    protected void init() {
        header = createHeaderNode();
    }

    public int size() {
        return size;
    }

    public boolean isEmpty() {
        return (size() == 0);
    }

    public Object get(int index) {
        LinkedListNode node = getNode(index, false);
        return node.getValue();
    }

    public int indexOf(Object value) {
        int i = 0;
        for (LinkedListNode node = header.next; node != header; node = node.next) {
            executedPredicate(4, node);
            if (isEqualValue(node.getValue(), value)) {
                executedPredicate(6, node);
                return i;
            } else {
                executedPredicate(7, node);
            }
            i++;
        }
        executedPredicate(5, null);
        return -1;
    }

    public int lastIndexOf(Object value) {
        int i = size - 1;
        for (LinkedListNode node = header.previous; node != header; node = node.previous) {
            executedPredicate(8, node);
            if (isEqualValue(node.getValue(), value)) {
                executedPredicate(10, node);
                return i;
            } else {
                executedPredicate(11, node);
            }
            i--;
        }
        executedPredicate(9, null);
        return -1;
    }

    public boolean contains(Object arg) {
        return indexOf(arg) != -1;
    }

    public boolean add(Object value) {
        addLast(value);
        return true;
    }

    public void add(int index, Object value) {
        LinkedListNode node = getNode(index, true);
        addNodeBefore(node, value);
    }

    public Object removeIndex(int index) {
        LinkedListNode node = getNode(index, false);
        Object oldValue = node.getValue();
        removeNode(node);
        return oldValue;
    }

    public boolean remove(Object value) {
        for (LinkedListNode node = header.next; node != header; node = node.next) {
            executedPredicate(12, node);
            if (isEqualValue(node.getValue(), value)) {
                executedPredicate(14, node);
                removeNode(node);
                return true;
            } else {
                executedPredicate(15, node);
            }
        }
        executedPredicate(13, null);

        return false;
    }

    public Object set(int index, Object value) {
        LinkedListNode node = getNode(index, false);
        Object oldValue = node.getValue();
        updateNode(node, value);
        return oldValue;
    }

    public void clear() {
        removeAllNodes();
    }

    public Object getFirst() {
        LinkedListNode node = header.next;
        if (node == header) {
            executedPredicate(16, node);
            throw new RuntimeException();
        } else {
            executedPredicate(17, node);
        }
        return node.getValue();
    }

    public Object getLast() {
        LinkedListNode node = header.previous;
        if (node == header) {
            executedPredicate(18, node);
            throw new RuntimeException();
        } else {
            executedPredicate(19, node);
        }
        return node.getValue();
    }

    public boolean addFirst(Object o) {
        addNodeAfter(header, o);
        return true;
    }

    public boolean addLast(Object o) {
        addNodeBefore(header, o);
        return true;
    }

    public Object removeFirst() {
        LinkedListNode node = header.next;
        if (node == header) {
            executedPredicate(20, node);
            throw new RuntimeException();
        } else {
            executedPredicate(21, node);
        }
        Object oldValue = node.getValue();
        removeNode(node);
        return oldValue;
    }

    public Object removeLast() {
        LinkedListNode node = header.previous;
        if (node == header) {
            executedPredicate(22, node);
            throw new RuntimeException();
        } else {
            executedPredicate(23, node);
        }
        Object oldValue = node.getValue();
        removeNode(node);
        return oldValue;
    }

    protected boolean isEqualValue(Object value1, Object value2) {
        return (value1 == value2 || (value1 == null ? false : value1
                .equals(value2)));
    }

    protected void updateNode(LinkedListNode node, Object value) {
        node.setValue(value);
    }

    protected LinkedListNode createHeaderNode() {
        return new LinkedListNode();
    }

    protected LinkedListNode createNode(Object value) {
        return new LinkedListNode(value);
    }

    protected void addNodeBefore(LinkedListNode node, Object value) {
        LinkedListNode newNode = createNode(value);
        addNode(newNode, node);
    }

    protected void addNodeAfter(LinkedListNode node, Object value) {
        LinkedListNode newNode = createNode(value);
        addNode(newNode, node.next);
    }

    protected void addNode(LinkedListNode nodeToInsert,
            LinkedListNode insertBeforeNode) {
        nodeToInsert.next = insertBeforeNode;
        nodeToInsert.previous = insertBeforeNode.previous;
        insertBeforeNode.previous.next = nodeToInsert;
        insertBeforeNode.previous = nodeToInsert;
        size++;
        modCount++;
    }

    protected void removeNode(LinkedListNode node) {
        node.previous.next = node.next;
        node.next.previous = node.previous;
        size--;
        modCount++;
    }

    protected void removeAllNodes() {
        header.next = header;
        header.previous = header;
        size = 0;
        modCount++;
    }

    protected LinkedListNode getNode(int index, boolean endMarkerAllowed)
            throws IndexOutOfBoundsException {
        if (index < 0) {
            executedPredicate(24, null);
            throw new IndexOutOfBoundsException("Couldn't get the node: "
                    + "index (" + index + ") less than zero.");
        } else {
            executedPredicate(25, null);
        }

        if (!endMarkerAllowed && index == size) {
            executedPredicate(26, null);
            throw new IndexOutOfBoundsException("Couldn't get the node: "
                    + "index (" + index + ") is the size of the list.");
        } else {
            executedPredicate(27, null);
        }

        if (index > size) {
            executedPredicate(28, null);
            throw new IndexOutOfBoundsException("Couldn't get the node: "
                    + "index (" + index + ") greater than the size of the "
                    + "list (" + size + ").");
        } else {
            executedPredicate(29, null);
        }

        LinkedListNode node;
        if (index < (size / 2)) {
            executedPredicate(30, null);
            node = header.next;
            for (int currentIndex = 0; currentIndex < index; currentIndex++) {
                executedPredicate(32, node);
                node = node.next;
            }
            executedPredicate(33, node);

        } else {
            executedPredicate(31, null);
            node = header;
            for (int currentIndex = size; currentIndex > index; currentIndex--) {
                executedPredicate(34, node);
                node = node.previous;
            }
            executedPredicate(35, node);
        }
        return node;
    }

    private static int NUM_OF_PREDICATES = 4;

    public static int numOfPredicates() {
        return NUM_OF_PREDICATES;
    }

    public void executedPredicate(int branch_id, LinkedListNode n) {
        int res = 0;
        if (n != null) {
            res |= 1 << 0;
            res |= (n.previous == null) ? 0 : 1 << 1;
            res |= (n.next == null) ? 0 : 1 << 2;
            res |= (n == header) ? 0 : 1 << 3;
        }
        System.out.println("branchId=" + branch_id + "; covered predicate combination=" + res);
    }

}
