package predicate.taco.treeset;

class TreeSetEntry {
    int key;
    TreeSetEntry left = null;
    TreeSetEntry right = null;
    TreeSetEntry parent;
    boolean color = true;

    /**
     * Make a new cell with given key, value, and parent, and with <tt>null</tt>
     * child links, and BLACK color.
     */
    TreeSetEntry(int key, TreeSetEntry parent) {
        this.key = key;

        this.parent = parent;
    }

    /**
     * Returns the key.
     * 
     * @return the key.
     */
    public int getKey() {
        return key;
    }

    @Override
    public int hashCode() {
        return key;
    }

    @Override
    public String toString() {
        String s = "{c:" + color + ";v" + key + "["
                + (left != null ? left.toString() : null) + "]["
                + (right != null ? right.toString() : null) + "]}";
        return s;
    }

}
