/**
 * Semi-automatically generated files used to measure predicate coverage.
 * Details can be found at http://mir.cs.illinois.edu/coverage
 */
package predicate.taco.treeset;

public class TreeSet_pred {

    private transient TreeSetEntry root = null;

    private transient int size = 0;

    private transient int modCount = 0;

    private final boolean RED = false;

    final boolean BLACK = true;

    @Override
    public String toString() {
        return root != null ? root.toString() : "null";
    }

    public boolean contains(int aKey) {
        return getEntry(aKey) != null;
    }

    private TreeSetEntry getEntry(int key) {
        TreeSetEntry p = root;
        while (p != null) {
            executedPredicate(0, p);
            if (key == p.key) {
                executedPredicate(2, p);
                return p;
            } else {
                executedPredicate(3, p);
                if (key < p.key) {
                    executedPredicate(4, p);
                    p = p.left;
                } else {
                    executedPredicate(5, p);
                    p = p.right;
                }
            }
        }
        executedPredicate(1, p);
        return null;
    }

    public boolean add(int aKey) {
        TreeSetEntry t = root;
        if (t == null) {
            executedPredicate(6, null);
            incrementSize();
            root = new TreeSetEntry(aKey, null);
            return false;
        } else {
            executedPredicate(7, t);
        }

        while (true) {
            executedPredicate(8, t);
            executedPredicate(9, t);
            if (aKey == t.key) {
                executedPredicate(10, t);
                return true;
            } else {
                executedPredicate(11, t);
                if (aKey < t.key) {
                    executedPredicate(12, t);
                    if (t.left != null) {
                        executedPredicate(14, t);
                        t = t.left;
                    } else {
                        executedPredicate(15, t);
                        incrementSize();
                        t.left = new TreeSetEntry(aKey, t);
                        fixAfterInsertion(t.left);
                        return false;
                    }
                } else {
                    executedPredicate(13, t);
                    if (t.right != null) {
                        executedPredicate(16, t);
                        t = t.right;
                    } else {
                        executedPredicate(17, t);
                        incrementSize();
                        t.right = new TreeSetEntry(aKey, t);
                        fixAfterInsertion(t.right);
                        return false;
                    }
                }
            }
        }
    }

    private void incrementSize() {
        modCount++;
        size++;
    }

    private static boolean colorOf(TreeSetEntry p) {
        boolean black = true;
        return (p == null ? black : p.color);
    }

    private static TreeSetEntry parentOf(TreeSetEntry p) {
        return (p == null ? null : p.parent);
    }

    private void setColor(TreeSetEntry p, boolean c) {
        if (p != null) {
            executedPredicate(18, p);
            p.color = c;
        } else {
            executedPredicate(19, null);
        }
    }

    private static TreeSetEntry leftOf(TreeSetEntry p) {
        return (p == null) ? null : p.left;
    }

    private static TreeSetEntry rightOf(TreeSetEntry p) {
        return (p == null) ? null : p.right;
    }

    private void rotateLeft(TreeSetEntry p) {
        TreeSetEntry r = p.right;
        p.right = r.left;
        if (r.left != null) {
            executedPredicate(20, r);
            r.left.parent = p;
        } else {
            executedPredicate(21, r);
        }

        r.parent = p.parent;
        if (p.parent == null) {
            executedPredicate(22, r);
            root = r;
        } else {
            executedPredicate(23, r);
            if (p.parent.left == p) {
                executedPredicate(24, r);
                p.parent.left = r;
            } else {
                executedPredicate(25, r);
                p.parent.right = r;
            }
        }

        r.left = p;
        p.parent = r;
    }

    private void rotateRight(TreeSetEntry p) {
        TreeSetEntry l = p.left;
        p.left = l.right;
        if (l.right != null) {
            executedPredicate(26, l);
            l.right.parent = p;
        } else {
            executedPredicate(27, l);
        }

        l.parent = p.parent;
        if (p.parent == null) {
            executedPredicate(28, l);
            root = l;
        } else {
            executedPredicate(29, l);
            if (p.parent.right == p) {
                executedPredicate(30, l);
                p.parent.right = l;
            } else {
                executedPredicate(31, l);
                p.parent.left = l;
            }
        }

        l.right = p;
        p.parent = l;
    }

    private void fixAfterInsertion(final TreeSetEntry entry) {
        TreeSetEntry x = entry;
        x.color = RED;
        while (x != null && x != root && x.parent.color == RED) {
            executedPredicate(32, x);
            if (parentOf(x) == leftOf(parentOf(parentOf(x)))) {
                executedPredicate(34, x);
                TreeSetEntry y = rightOf(parentOf(parentOf(x)));
                if (colorOf(y) == RED) {
                    executedPredicate(36, y);
                    setColor(parentOf(x), BLACK);
                    setColor(y, BLACK);
                    setColor(parentOf(parentOf(x)), RED);
                    x = parentOf(parentOf(x));
                } else {
                    executedPredicate(37, y);
                    if (x == rightOf(parentOf(x))) {
                        executedPredicate(38, x);
                        x = parentOf(x);
                        rotateLeft(x);
                    } else {
                        executedPredicate(39, x);
                    }

                    setColor(parentOf(x), BLACK);
                    setColor(parentOf(parentOf(x)), RED);
                    if (parentOf(parentOf(x)) != null) {
                        executedPredicate(40, x);
                        rotateRight(parentOf(parentOf(x)));
                    } else {
                        executedPredicate(41, x);
                    }
                }
            } else {
                executedPredicate(35, x);
                TreeSetEntry y = leftOf(parentOf(parentOf(x)));
                if (colorOf(y) == RED) {
                    executedPredicate(42, y);
                    setColor(parentOf(x), BLACK);
                    setColor(y, BLACK);
                    setColor(parentOf(parentOf(x)), RED);
                    x = parentOf(parentOf(x));
                } else {
                    executedPredicate(43, y);
                    if (x == leftOf(parentOf(x))) {
                        executedPredicate(44, y);
                        x = parentOf(x);
                        rotateRight(x);
                    } else {
                        executedPredicate(45, y);
                    }

                    setColor(parentOf(x), BLACK);
                    setColor(parentOf(parentOf(x)), RED);
                    if (parentOf(parentOf(x)) != null) {
                        executedPredicate(46, y);
                        rotateLeft(parentOf(parentOf(x)));
                    } else {
                        executedPredicate(47, y);
                    }
                }
            }
        }
        executedPredicate(33, x);
        root.color = BLACK;
    }

    public boolean remove(int aKey) {
        TreeSetEntry p = getEntry(aKey);
        if (p == null) {
            executedPredicate(48, null);
            return false;
        } else {
            executedPredicate(49, p);
        }

        deleteEntry(p);
        return true;
    }

    private void deleteEntry(TreeSetEntry p) {
        decrementSize();
        if (p.left != null && p.right != null) {
            executedPredicate(50, p);
            TreeSetEntry s = successor(p);
            p.key = s.key;
            p = s;
        } else {
            executedPredicate(51, p);
        }

        TreeSetEntry replacement = (p.left != null ? p.left : p.right);
        if (replacement != null) {
            executedPredicate(52, replacement);
            replacement.parent = p.parent;
            if (p.parent == null) {
                executedPredicate(54, replacement);
                root = replacement;
            } else {
                executedPredicate(55, replacement);
                if (p == p.parent.left) {
                    executedPredicate(56, replacement);
                    p.parent.left = replacement;
                } else {
                    executedPredicate(57, replacement);
                    p.parent.right = replacement;
                }
            }

            p.left = p.right = p.parent = null;
            if (p.color == BLACK) {
                executedPredicate(58, replacement);
                fixAfterDeletion(replacement);
            } else {
                executedPredicate(59, replacement);
            }
        } else {
            executedPredicate(53, p);
            if (p.parent == null) {
                executedPredicate(60, p);
                root = null;
            } else {
                executedPredicate(61, p);
                if (p.color == BLACK) {
                    executedPredicate(62, p);
                    fixAfterDeletion(p);
                } else {
                    executedPredicate(63, p);
                }
                if (p.parent != null) {
                    executedPredicate(64, p);
                    if (p == p.parent.left) {
                        executedPredicate(66, p);
                        p.parent.left = null;
                    } else {
                        executedPredicate(67, p);
                        if (p == p.parent.right) {
                            executedPredicate(68, p);
                            p.parent.right = null;
                        } else {
                            executedPredicate(69, p);
                        }
                    }
                    p.parent = null;
                } else {
                    executedPredicate(65, p);
                }
            }
        }
    }

    private void fixAfterDeletion(final TreeSetEntry entry) {
        TreeSetEntry x = entry;
        while (x != root && colorOf(x) == BLACK) {
            executedPredicate(70, x);
            if (x == leftOf(parentOf(x))) {
                executedPredicate(72, x);
                TreeSetEntry sib = rightOf(parentOf(x));
                if (colorOf(sib) == RED) {
                    executedPredicate(74, sib);
                    setColor(sib, BLACK);
                    setColor(parentOf(x), RED);
                    rotateLeft(parentOf(x));
                    sib = rightOf(parentOf(x));
                } else {
                    executedPredicate(75, sib);
                }

                if (colorOf(leftOf(sib)) == BLACK
                        && colorOf(rightOf(sib)) == BLACK) {
                    executedPredicate(76, sib);
                    setColor(sib, RED);
                    x = parentOf(x);
                } else {
                    executedPredicate(77, sib);
                    if (colorOf(rightOf(sib)) == BLACK) {
                        executedPredicate(78, sib);
                        setColor(leftOf(sib), BLACK);
                        setColor(sib, RED);
                        rotateRight(sib);
                        sib = rightOf(parentOf(x));
                    } else {
                        executedPredicate(79, sib);
                    }

                    setColor(sib, colorOf(parentOf(x)));
                    setColor(parentOf(x), BLACK);
                    setColor(rightOf(sib), BLACK);
                    rotateLeft(parentOf(x));
                    x = root;
                }
            } else {
                executedPredicate(73, x);
                TreeSetEntry sib = leftOf(parentOf(x));
                if (colorOf(sib) == RED) {
                    executedPredicate(80, sib);
                    setColor(sib, BLACK);
                    setColor(parentOf(x), RED);
                    rotateRight(parentOf(x));
                    sib = leftOf(parentOf(x));
                } else {
                    executedPredicate(81, sib);
                }

                if (colorOf(rightOf(sib)) == BLACK
                        && colorOf(leftOf(sib)) == BLACK) {
                    executedPredicate(82, sib);
                    setColor(sib, RED);
                    x = parentOf(x);
                } else {
                    executedPredicate(83, sib);
                    if (colorOf(leftOf(sib)) == BLACK) {
                        executedPredicate(84, sib);
                        setColor(rightOf(sib), BLACK);
                        setColor(sib, RED);
                        rotateLeft(sib);
                        sib = leftOf(parentOf(x));
                    } else {
                        executedPredicate(85, sib);
                    }

                    setColor(sib, colorOf(parentOf(x)));
                    setColor(parentOf(x), BLACK);
                    setColor(leftOf(sib), BLACK);
                    rotateRight(parentOf(x));
                    x = root;
                }
            }
        }
        executedPredicate(71, x);
        setColor(x, BLACK);
    }

    private void decrementSize() {
        modCount++;
        size--;
    }

    private TreeSetEntry successor(TreeSetEntry t) {
        if (t == null) {
            executedPredicate(86, null);
            return null;
        } else {
            executedPredicate(87, t);
            if (t.right != null) {
                executedPredicate(88, t);
                TreeSetEntry p = t.right;
                while (p.left != null) {
                    executedPredicate(90, p);
                    p = p.left;
                }
                executedPredicate(91, p);
                return p;
            } else {
                executedPredicate(89, t);
                TreeSetEntry p = t.parent;
                TreeSetEntry ch = t;
                while (p != null && ch == p.right) {
                    executedPredicate(92, p);
                    ch = p;
                    p = p.parent;
                }
                executedPredicate(93, p);
                return p;
            }
        }
    }

    private static int NUM_OF_PREDICATES = 6;

    public static int numOfPredicates() {
        return NUM_OF_PREDICATES;
    }

    public void executedPredicate(int branch_id, TreeSetEntry n) {
        int res = 0;
        if (n != null) {
            res |= 1 << 0;
            res |= (n.left == null) ? 0 : 1 << 1;
            res |= (n.right == null) ? 0 : 1 << 2;
            res |= (n.parent == null) ? 0 : 1 << 3;
            res |= (n.color == RED) ? 0 : 1 << 4;
            res |= (n == root) ? 0 : 1 << 5;
        }
        System.out.println("branchId=" + branch_id + "; covered predicate combination=" + res);
    }

}
